//Marshmallow on a stick
//By Gothboy77 BLID 14329
//Can be roasted over a fire and eaten
//------------------------------------
//Sound Data
datablock AudioProfile(MarshRoastSFX: Synth_00_Sound)
{
	filename = "./Roast.wav";
};
datablock AudioProfile(MarshEatSFX: Synth_00_Sound)
{
	filename = "./Eat.wav";
};
//Item and Image Data
datablock ItemData(MarshmallowStickItem)
{
	shapeFile = "./mesh_MarshmallowStick.dts";
	iconName = "./icon_MarshmallowStick";
	uiName = "Marshmallow Stick";
	image = MarshmallowStickImage;
	canDrop = true;
	doColorShift = false;
	mass = 2;
	density = 0.2;
	elasticity = 0.2;
	friction = 8.0;
};
datablock ShapeBaseImageData(MarshmallowStickImage)
{
	shapeFile = "./mesh_MarshmallowStick.dts";
	mountPoint = 0;
	offset = "0 0 0.1";
	rotation = eulerToMatrix("0 0 0");
	eyeOffset = "0 0 0";
	className = "WeaponImage";
	item = MarshmallowStickItem;
	melee = false;
	emap = true;
	armReady = true;
	correctMuzzleVector = false;
	doRetraction = false;
	doColorShift = false;
    //Image states
	stateName[0]                     = "Equip";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]      = "Ready";
	stateScript[0]		 			 = "onEquip";
	stateSequence[0]				 = "equip";
	stateWaitForTimeout[0]           = true;
	
	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	
	stateName[2]                     = "Fire";
	stateScript[2]                   = "onFire";
	stateFire[2]                     = true;
	stateAllowImageChange[2]         = false;
	stateTimeoutValue[2]             = 0.2;
	stateTransitionOnTimeout[2]      = "Roast";
	
	stateName[3]                     = "Roast";
	stateTransitionOnTimeout[3]      = "Done";
	stateSequence[3]                 = "fire";
	stateTimeoutValue[3]             = 0.8;
	stateAllowImageChange[3]         = false;
	stateEmitter[3]					 = gunSmokeEmitter;
	stateEmitterTime[3]				 = 0.8;
	stateEmitterNode[3]				 = "muzzleNode";
	stateScript[3]                   = "onRoast";
	stateWaitForTimeout[3]           = true;

	stateName[4]                     = "Done";
	stateTransitionOnTimeout[4]      = "Ready";
	stateTimeoutValue[4]             = 0.2;
	stateScript[4]					 = "onDone";

};
//Roasted Marshmallow Image
datablock ShapeBaseImageData(MarshmallowStickRImage : MarshmallowStickImage)
{
	shapeFile = "./mesh_MarshmallowStickR.dts";
	mountPoint = 0;
	offset = "0 0 0.1";
	rotation = eulerToMatrix("0 0 0");
	eyeOffset = "0 0 0";
	className = "WeaponImage";
	melee = false;
	emap = true;
	armReady = true;
	correctMuzzleVector = false;
	doRetraction = false;
	doColorShift = false;
    //Image states
	stateName[0]                     = "Equip";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]      = "Ready";
	stateScript[0]		 			 = "onEquip";
	stateWaitForTimeout[0]           = true;
	
	stateName[1]                     = "Ready";
	stateSequence[1]				 = "ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = false;
	
	stateName[2]                     = "Fire";
	stateScript[2]                   = "onFire";
	stateFire[2]                     = true;
	stateAllowImageChange[2]         = false;
	stateTimeoutValue[2]             = 0.2;
	stateTransitionOnTimeout[2]      = "Eat";
	
	stateName[3]                     = "Eat";
	stateTransitionOnTimeout[3]      = "Done";
	stateTimeoutValue[3]             = 0.2;
	stateSequence[3]                 = "eat";
	stateAllowImageChange[3]         = false;
	stateScript[3]                   = "onEat";
	stateWaitForTimeout[3]           = true;

	stateName[4]                     = "Done";
	stateTransitionOnTimeout[4]      = "Done";
	stateScript[4]					 = "onDone";
	stateTimeoutValue[4]             = 0.2;

};
//Burnt Marshmallow (The best way to eat them!!)
datablock ShapeBaseImageData(MarshmallowStickBImage : MarshmallowStickRImage)
{
	shapeFile = "./mesh_MarshmallowStickB.dts";
	mountPoint = 0;
	offset = "0 0 0.1";
	rotation = eulerToMatrix("0 0 0");
	eyeOffset = "0 0 0";
	className = "WeaponImage";
	melee = false;
	emap = true;
	armReady = true;
	correctMuzzleVector = false;
	doRetraction = false;
	doColorShift = false;
    //Image states
	stateName[0]                     = "Equip";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]      = "Ready";
	stateScript[0]		 			 = "onEquip";
	stateWaitForTimeout[0]           = true;
	
	stateName[1]                     = "Ready";
	stateSequence[1]				 = "ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = false;
	
	stateName[2]                     = "Fire";
	stateScript[2]                   = "onFire";
	stateFire[2]                     = true;
	stateAllowImageChange[2]         = false;
	stateTimeoutValue[2]             = 0.2;
	stateTransitionOnTimeout[2]      = "Eat";
	
	stateName[3]                     = "Eat";
	stateTransitionOnTimeout[3]      = "Done";
	stateTimeoutValue[3]             = 0.2;
	stateSequence[3]                 = "eat";
	stateAllowImageChange[3]         = false;
	stateScript[3]                   = "onEat";
	stateWaitForTimeout[3]           = true;

	stateName[4]                     = "Done";
	stateTransitionOnTimeout[4]      = "Done";
	stateScript[4]					 = "onDone";
	stateTimeoutValue[4]             = 0.2;

};
function MarshmallowStickImage::onEquip(%this, %obj, %slot)
{
	//Keep our cooked Marshmallow
	if(%obj.roastedMarshmallow == 1)
	{
		%obj.unmountimage(0);
		%obj.mountimage(MarshmallowStickRImage,0);
	}
	if(%obj.burntMarshmallow == 1)
	{
		%obj.unmountimage(0);
		%obj.mountimage(MarshmallowStickBImage,0);
	}
}
function MarshmallowStickImage::onFire(%this, %obj, %slot)
{
	//Make sure we are looking at a brick with fire
	%start = %obj.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%obj.getMuzzleVector(0), 7));
	%typemasks = $TypeMasks::FxBrickObjectType | $TypeMasks::FxBrickAlwaysObjectType;
	%ray = containerRayCast(%start, %end, %typemasks, %obj);
	if(isObject(%col = firstWord(%ray)))
	{	
		if(isObject(%emitter = %col.emitter))
		{	
			if(%emitter.emitter.uiName $= "Fire A" || %emitter.emitter.uiName $= "Fire B" || %emitter.emitter.uiName $= "Player Jet" || %col.isFire == 1)
			{
				continue;
			}
			else
			{
				bottomPrint(%obj.client,"You must be close to a fire and looking at it to roast a Marshmallow", 4);
				return;
			}
		}
		else
		{
			bottomPrint(%obj.client,"You must be close to a fire and looking at it to roast a Marshmallow", 4);
			return;
		}
		
	}
	else
	{
		bottomPrint(%obj.client,"You must be close to a fire and looking at it to roast a Marshmallow", 4);
		return;
	}
}
function MarshmallowStickImage::onDone(%this, %obj, %slot)
{
	//Make sure we are looking at a brick with fire
	%start = %obj.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%obj.getMuzzleVector(0), 7));
	%typemasks = $TypeMasks::FxBrickObjectType | $TypeMasks::FxBrickAlwaysObjectType;
	%ray = containerRayCast(%start, %end, %typemasks, %obj);
	if(isObject(%col = firstWord(%ray)))
	{	
		if(isObject(%emitter = %col.emitter))
		{	
			if(%emitter.emitter.uiName $= "Fire A" || %emitter.emitter.uiName $= "Fire B" || %emitter.emitter.uiName $= "Player Jet" || %col.isFire == 1)
			{
				%obj.unmountImage(0);
				%obj.mountimage(MarshmallowStickRImage,0);
				%obj.roastedMarshmallow = 1;
				serverPlay3D(MarshRoastSFX,%obj.getPosition());
			}
			else
			{
				bottomPrint(%obj.client,"You must be close to a fire and looking at it to roast a Marshmallow", 4);
				return;
			}
		}
		else
		{
			bottomPrint(%obj.client,"You must be close to a fire and looking at it to roast a Marshmallow", 4);
			return;
		}
		
	}
	else
	{
		bottomPrint(%obj.client,"You must be close to a fire and looking at it to roast a Marshmallow", 4);
		return;
	}
}
//Eat the roasted marshmallow
function MarshmallowStickRImage::onFire(%this, %obj, %slot)
{
	//The stick is empty, reuse the item
	if(%obj.roastedMarshmallow == 0)
	{
		bottomPrint(%obj.client,"You do not have a marshmallow on your stick", 4);
		return;
	}
	else
	{
		%obj.roastedMarshmallow = 0;
	}
}
//Eat the burnt marshmallow
function MarshmallowStickBImage::onFire(%this, %obj, %slot)
{
	//The stick is empty, reuse the item
	if(%obj.burntMarshmallow == 0)
	{
		bottomPrint(%obj.client,"You do not have a marshmallow on your stick", 4);
		return;
	}
	else
	{
		%obj.burntMarshmallow = 0;
	}
}
function MarshmallowStickRImage::onEat(%this, %obj, %slot)
{
	serverPlay3D(MarshEatSFX,%obj.getPosition());
}
function MarshmallowStickBImage::onEat(%this, %obj, %slot)
{
	serverPlay3D(MarshEatSFX,%obj.getPosition());
}
//Packaged Functionality
package Package_RoastMarshmallows
{
	function Armor::onTrigger(%this,%obj,%slot,%val)
	{
		if(%obj.getMountedImage(0) $= MarshmallowStickRImage.getID() && %slot $= 4 && %val)
		{
			//Make sure we are looking at a brick with fire
			%start = %obj.getEyePoint();
			%end = vectorAdd(%start, vectorScale(%obj.getMuzzleVector(0), 7));
			%typemasks = $TypeMasks::FxBrickObjectType | $TypeMasks::FxBrickAlwaysObjectType;
			%ray = containerRayCast(%start, %end, %typemasks, %obj);
			if(isObject(%col = firstWord(%ray)))
			{	
				if(isObject(%emitter = %col.emitter))
				{	
					if(%emitter.emitter.uiName $= "Fire A" || %emitter.emitter.uiName $= "Fire B" || %emitter.emitter.uiName $= "Player Jet" || %col.isFire == 1)
					{
						%obj.unmountImage(0);
						%obj.mountimage(MarshmallowStickBImage,0);
						%obj.roastedMarshmallow = 0;
						%obj.burntMarshmallow = 1;
						serverPlay3D(MarshRoastSFX,%obj.getPosition());
					}
				}
			}
			else
			{
				if(%obj.burntMarshmallow == 0)
					bottomPrint(%obj.client,"You must be close to a fire and looking at it to burn a Marshmallow", 4);
			}
		}
		return Parent::onTrigger(%this,%obj,%slot,%val);
	}
};
activatePackage(Package_RoastMarshmallows);